Mobike/Mobike/urls.py
from django.contrib import admin
from django.urls import path, include 

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include("main.urls"))
]

Mobike/main/urls.py
from django.urls import path, include
from . import views

app_name='main'

urlpatterns = [
    path('', views.homepage, name='homepage'),
    path('registro/', views.registro, name='registro'),
    path('logout/', views.logout_request, name= 'logout'),
    path('login/', views.login_request, name="login"),
    path('cliente/', views.cliente, name= 'cliente'),
    path('view_admin/', views.view_admin, name= 'view_admin'),
    path('view_funcio', views.view_funcio, name= 'view_funcio'),
]

Mobike/main/models.py
from django.db import models

# Create your models here.

class Cliente(models.Model):
    Nombre= models.CharField(max_length=200)
    Apellido=models.CharField(max_length=200)
    Contraseña= models.CharField(max_length=200)
    Correo= models.CharField(max_length=200)
    Telefono_Contacto= models.CharField(max_length=10)
    Tarjeta_Bancaria= models.CharField(max_length=12)
    Run= models.CharField(max_length=10)



class Funcionario_model(models.Model):
    funcionario = models.CharField(max_length=20)
    contenido = models.CharField(max_length=500)
    fecha = models.DateField()
    
class Admin_model1(models.Model):
    adm_nombre = models.CharField(max_length=200)
    adm_apellido = models.CharField(max_length=200)
    adm_contraseña = models.CharField(max_length=200)
    adm_correo = models.CharField(max_length=200)
    adm_telefono = models.CharField(max_length=10)
    adm_bco = models.CharField(max_length=16)
    adm_run = models.CharField(max_length=10)

Mobike/main/forms.py
from django import forms
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User

class UserRegisterForm(UserCreationForm):
    username = forms.CharField(label='Nombre', max_length=200)
    apellido = forms.CharField(label='Apellido', max_length=200)
    email = forms.EmailField()
    password1 = forms.CharField(label='Contraseña', widget=forms.PasswordInput)
    password2 = forms.CharField(label='Confirma Contraseña', widget=forms.PasswordInput)
    telefono = forms.CharField(label='telefono', max_length=12)
    tarjeta_bco = forms.CharField(label='Tarjeta de Credito', max_length=12)
    rut = forms.CharField(label='Rut', max_length=10)


    class Meta:
        model = User
        fields = ['username', 'apellido' , 'email', 'password1', 'password2',
                  'telefono', 'tarjeta_bco', 'rut']
        help_text = {k:"" for k in fields}
        helptext= {k:"" for k in fields}

Mobike/main/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.forms import AuthenticationForm
from django.contrib.auth import login, logout, authenticate
from django.contrib import messages
from .forms import UserRegisterForm
from django.contrib.auth.decorators import login_required, permission_required
# Create your views here.

def homepage(request):
    return render(request, 'main/inicio.html',{})

def registro(request):
    if request.method == 'POST':
        form = UserRegisterForm(request.POST)
        if form.is_valid():
            username = form.cleaned_data['username']
            messages.success(request, f'Usuario {username} creado')
            form.save()
            return redirect('main:homepage')
    else:
        form = UserRegisterForm()

    context = {'form': form}
    return render(request, 'main/registro.html',context)
    

def logout_request(request):
    logout(request)
    messages.info(request, "saliste exitosamente")
    return redirect("main:homepage")

def login_request(request):
    if request.method == "POST":
        form = AuthenticationForm(request, data=request.POST)
        if form.is_valid():
            usuario = form.cleaned_data.get('username')
            contraseña = form.cleaned_data.get('password')
            user = authenticate(username= usuario, password = contraseña)
            if user is not None:
                login(request,user)
                messages.info(request, f"estas logeado como {usuario}")
                return redirect("main:homepage")
            else:
                messages.error(request, "Usuario o contraseña equivocada")
        else:
            messages.error(request, "Usuario o contraseña equivocada")

    form = AuthenticationForm()
    return render(request, "main/login.html", {"form": form})



def cliente(request):
    return render (request, 'main/cliente.html', {})

@permission_required('main.add_admin_model1')
@login_required
def view_admin(request):
    return render (request, 'main/view_admin.html',{})

@permission_required('main.add_funcionario_model')
def view_funcio(request):
    return render (request, 'main/view_funcio.html',{})

Mobike/main/templates/main/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css"
        integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU" crossorigin="anonymous">
</head>
<body>

<nav>
    <div class="nav-wrapper #f57c00 orange darken-2">
        <a href="#" class="brand-logo">Mobike</a>
         <ul id="nav-mobile" class="right hide-on-med-and-down">
            {% if user.is_authenticated %}
            <li><a href="{% url 'main:homepage'%}">Inicio</a></li>
            <li><a href="{% url 'main:view_admin' %}">Administrador</a></li>
            <li><a href="{% url 'main:view_funcio' %}">Funcionario</a></li>
            <li><a href="{% url 'main:cliente' %}">Cliente</a></li> 
            <li><a href="#">Usuario: {{user.username}}</a></li>           
            <li><a href="{% url 'main:logout' %}">Salir</a></li>
            {% else %}
            <li><a href="{% url 'main:homepage'%}">Inicio</a></li>
            <li><a href="{% url 'main:registro' %}">Registro</a></li>            
            <li><a href="{% url 'main:login' %}">Entrar</a></li>
            {% endif %}
        </ul>
    </div>
</nav>
<div class="container">
<br>
    {% block content %}
    {% endblock %}
<br>
</div>
{% if messages %}
    {% for messages in messages %}
        <!-- ok -->
        {% if message.tags == 'success' %}
            <script>
                 M.toast({
                    html: '{{message}}',
                    classes: 'green rounded',
                    displayLength: 2000,                    
                });
            </script>
        {% endif %}
        <!-- info -->
        {% if message.tags == 'info' %}
            <script>
                M.toast({
                    html: '{{message}}',
                    classes: 'blue rounded',
                    displayLength: 2000,                    
                });
            </script>                
        {% endif %}
        <!-- warning-->
        {% if message.tags == 'warning' %}
            <script>
                M.toast({
                    html: '{{message}}',
                    classes: 'orange rounded',
                    displayLength: 2000,                    
                });
            </script>                
        {% endif %}
        <!-- error -->
        {% if message.tags == 'error' %}
            <script>
                M.toast({
                    html: '{{message}}',
                    classes: 'red rounded',
                    displayLength: 2000,                    
                });
            </script>
        {% endif %}
    {% endfor %}
{% endif %}
    <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"></script>
</body>
</html>

Mobike/main/templates/main/cliente.html
{% extends "main/base.html" %}
{% block content %}
  <div class="row">
    <div class="col s12 m4">
      <div class="card blue-grey darken-1">
        <div class="card-image">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Consultar Historial de viajes</span>
        </div>
        <div class="card-content">
          <p>Permite visualizar el historial de viajes realizados</p>
        </div>
        <div class="card-action">
          <a href="#">Historial de viajes</a>
        </div>
      </div>
    </div>
    <div class="col s12 m4">
      <div class="card #0097a7 cyan darken-2">
        <div class="card-image #0097a7 cyan darken-2">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Consultar saldo tarjeta</span>
        </div>
        <div class="card-content">
          <p>Permite visualizar el saldo de la tarjeta, y cargarla en caso de necsitarlo</p>
        </div>
        <div class="card-action">
          <a href="#">Ver tarjeta</a>
        </div>
      </div>
    </div>
    <div class="col s12 m4">
      <div class="card #00796b teal darken-2">
        <div class="card-image ">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Arrendar bicicleta</span>
        </div>
        <div class="card-content">
          <p>Inicia la camara para escanear un codigo QR y comenzar el arriendo de la bicicleta</p>
        </div>
        <div class="card-action">
          <a href="#">Arrendar bicicleta</a>
        </div>
      </div>
    </div>
  </div>
{% endblock %}

Mobike/main/templates/main/inicio.html
{% extends "main/base.html" %}
{% block content %}
<div class="row">
    <div class="col s12 m6">
      <div class="card #1e88e5 blue darken-1">
        <div class="card-image">
          <img src="https://scontent.fscl18-1.fna.fbcdn.net/v/t1.0-0/p526x296/82469038_2415181558812896_4548168785584469880_o.jpg?_nc_cat=108&ccb=2&_nc_sid=8024bb&_nc_ohc=5lnYdkwZYp0AX_ihFFf&_nc_ht=scontent.fscl18-1.fna&tp=6&oh=7341d7ec0af13578a228b02035b732c4&oe=5FD27401">
        </div>
        <div class="card-content">
          <p>Mobike es una inicitiva que prentende mantener un área fuera de vehiculos motorizados para seguir siendo verde</p>
        </div>
        <div class="card-action">
          <a href="{% url 'main:login'%}">Iniciar Sesion</a>
          <a href="{% url 'main:registro'%}">Registrarse</a>
        </div>
      </div>
    </div>
    <div class="col s12 m6">
      <div class="card #1e88e5 blue darken-1">
        <div class="card-image #1e88e5 blue darken-1">
          <img src="https://scontent.fscl18-1.fna.fbcdn.net/v/t1.0-9/p960x960/110242239_2431888357142216_6095766129548037237_o.png?_nc_cat=102&ccb=2&_nc_sid=8024bb&_nc_ohc=KSB7KrMZ3P8AX9ABXiS&_nc_ht=scontent.fscl18-1.fna&oh=857f78586e98a418ff927e5ef6b092fc&oe=5FD3B85F">
        </div>
        <div class="card-content">
          <p>Te encuentras registrado o quieres iniciar sesion</p>
        </div>
        <div class="card-action">
          <a href="#">¿Quienes Somos?</a>
        </div>
      </div>
    </div>
  </div>
{% endblock content %}

Mobike/main/templates/main/login.html
{% extends "main/base.html" %}

{% block content %}

<form action="" method="POST">
    {% csrf_token %}
    {{form.as_p}}
    <button class="btn" type="submit">Registrar</button>
</form>
{% endblock %}

Mobike/main/templates/main/registro.html
{% extends "main/base.html" %}
{% block content %}

<form class="form" action="{% url 'main:registro' %}" method="POST">
    {% csrf_token %}
    {{form.as_p}}

    <button type="submit" id="submit">Registrarse</button>
</form>

{% endblock content %}

Mobike/main/templates/main/view_admin.html
{% extends "main/base.html" %}
{% block content %}
  <div class="row">
    <div class="col s12 m3">
      <div class="card blue-grey darken-1">
        <div class="card-image">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Reiniciar usuario</span>
        </div>
        <div class="card-content">
          <p>Se reinicia el usuario a sus credenciales iniciales</p>
        </div>
        <div class="card-action">
          <a href="#">Reiniciar</a>
        </div>
      </div>
    </div>
    <div class="col s12 m3">
      <div class="card #0097a7 cyan darken-2">
        <div class="card-image #0097a7 cyan darken-2">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Eliminar usuario</span>
        </div>
        <div class="card-content">
          <p>Se eliminara el usuario ingresando su usuario</p>
        </div>
        <div class="card-action">
          <a href="#">Eliminar</a>
        </div>
      </div>
    </div>
    <div class="col s12 m3">
      <div class="card #00796b teal darken-2">
        <div class="card-image ">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Agregar usuario</span>
        </div>
        <div class="card-content">
          <p>Agrega un usuario para produccion(funcionario)</p>
        </div>
        <div class="card-action">
          <a href="#">Agregar usuario</a>
        </div>
      </div>
    </div>
    <div class="col s12 m3">
      <div class="card #2196f3 blue">
        <div class="card-image ">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Modificar permisos</span>
        </div>
        <div class="card-content">
          <p>Se podran modificar los permisos de los usuarios </p>
        </div>
        <div class="card-action">
          <a href="#">Modificar</a>
        </div>
      </div>
    </div>
    <div class="col s12 m3">
      <div class="card #b388ff deep-purple accent-1">
        <div class="card-image">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Buscar reporte</span>
        </div>
        <div class="card-content">
          <p>Permite buscar un reporte por su ID</p>
        </div>
        <div class="card-action">
          <a href="#">Buscar reporte</a>
        </div>
      </div>
    </div>
    <div class="col s12 m3">
      <div class="card #1b5e20 green darken-4">
        <div class="card-image #1b5e20 green darken-4">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Eliminar reporte</span>
        </div>
        <div class="card-content">
          <p>Permite eliminar un reporte por su ID</p>
        </div>
        <div class="card-action">
          <a href="#">Eliminar reporte</a>
        </div>
      </div>
    </div>
    <div class="col s12 m3">
      <div class="card #fdd835 yellow darken-1">
        <div class="card-image ">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Agregar reporte</span>
        </div>
        <div class="card-content">
          <p>Permite agregar un reporte</p>
        </div>
        <div class="card-action">
          <a href="#">Agregar reporte</a>
        </div>
      </div>
    </div>
    <div class="col s12 m3">
      <div class="card #6d4c41 brown darken-1">
        <div class="card-image ">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Registrar cliente</span>
        </div>
        <div class="card-content">
          <p>Permite agregar un cliente</p>
        </div>
        <div class="card-action">
          <a href="#">Registrar cliente</a>
        </div>
      </div>
    </div>
  </div>
{% endblock %}

Mobike/main/templates/main/view_funcio.html
{% extends "main/base.html" %}
{% block content %}
  <div class="row">
    <div class="col s12 m3">
      <div class="card blue-grey darken-1">
        <div class="card-image">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Buscar Reporte</span>
        </div>
        <div class="card-content">
          <p>Permite buscar un reporte por su ID</p>
        </div>
        <div class="card-action">
          <a href="#">Buscar reporte</a>
        </div>
      </div>
    </div>
    <div class="col s12 m3">
      <div class="card #0097a7 cyan darken-2">
        <div class="card-image #0097a7 cyan darken-2">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Eliminar reporte</span>
        </div>
        <div class="card-content">
          <p>Permite eliminar un reporte por su ID</p>
        </div>
        <div class="card-action">
          <a href="#">Eliminar reporte</a>
        </div>
      </div>
    </div>
    <div class="col s12 m3">
      <div class="card #00796b teal darken-2">
        <div class="card-image ">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Agregar reporte</span>
        </div>
        <div class="card-content">
          <p>Permite agregar un reporte</p>
        </div>
        <div class="card-action">
          <a href="#">Agregar reporte</a>
        </div>
      </div>
    </div>
    <div class="col s12 m3">
      <div class="card #2196f3 blue">
        <div class="card-image ">
          <img src="https://mobike.com/global/public/whitesignet.jpg">
          <span class="card-title">Registrar cliente</span>
        </div>
        <div class="card-content">
          <p>Permite agregar un cliente</p>
        </div>
        <div class="card-action">
          <a href="#">Registrar cliente</a>
        </div>
      </div>
    </div>
  </div>
{% endblock %}